<?php
/////////////////////////////////////////////////////////
//Copyright (C) 2005 Brian Engert
//
//This program is free software; you can redistribute it and/or modify 
//it under the terms of the GNU General Public License as published by 
//the Free Software Foundation; either version 2 of the License, or 
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful, 
//but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
//or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
//for more details.
//
//You should have received a copy of the GNU General Public License along 
//with this program; if not, write to the 
//Free Software Foundation, Inc., 
//59 Temple Place, Suite 330, 
//Boston, MA 02111-1307 USA
////////////////////////////////////////////////////////

echo "<pre>";
/*$time_start = microtime(true);
echo "<TABLE border=\"1\">
<TR><TH>name<TH>level<TH>race<TH>class<TH>rank";*/
processGuild("Mug'thol", "Havok");
/*echo "</TABLE>";
$time_end = microtime(true);
$execute_time = $time_end - $time_start;
echo "<pre>total time  in seconds ". $execute_time ;*/

function processGuild($realm, $name)
{
//http://armory.worldofwarcraft.com/guild-info.xml?r=Mug'thol&n=Havok&p=1
	$pages = 1;//start this at 1 we will reset it later on
	$currentPage = 1;
	while ($currentPage <= $pages)
	{
		$ch = curl_init();

		// set URL and other appropriate options
		curl_setopt($ch, CURLOPT_URL, "http://armory.worldofwarcraft.com/guild-info.xml?r=$realm&n=$name&p=$currentPage");
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		
		// grab URL
		$page = curl_exec($ch);
		// close cURL resource, and free up system resources
		curl_close($ch);
		
		//get the real number of pages
		if ($currentPage == 1)
		{
		//type="text">&nbsp;of&nbsp;<strong>
		//</strong></span>
			preg_match('/&nbsp;of&nbsp;<strong>([0-9]+)<\/strong><\/span>/', $page, $matches);
			//print_r($matches);
			$pages = $matches[1];
		}
		
		//get all of the charecters for this page
		preg_match_all('/javascript:ajaxLink(.*)character-sheet.xml(.*<td align="right">.*)<td align="right">/', $page, $matches);
		//print_r($matches);
		parseGuildCharecters($matches[2]);
		
		$currentPage++;
	}
}
//this should be passed an array of strings
//?r=Mug%27thol&n=Ogle%22)"><strong>Ogle</strong></a></q></td><td align="center"><q>70</q></td><td align="right"><img src="images/icons/race/2-0.png" class="ci" onmouseout="hideTip()" onmouseover="showTip('Orc')"></td><td align="left"><img src="images/icons/class/3.png" class="ci" onmouseout="hideTip()" onmouseover="showTip('Hunter')"></td><td align="center"><q><strong class="gm">Guild Master</strong></q></td>
function parseGuildCharecters($charecters)
{
	//var_dump($charecters);
	foreach ($charecters as $charline)
	{
		//echo $charline . "\n\n\n\n";
		preg_match('/<strong>(.*)<\/strong><\/a><\/q>/', $charline, $matches);
		$name = $matches[1];
		preg_match('/<q>([0-9]+)<\/q>/', $charline, $matches);
		$level = $matches[1];
		preg_match('/onmouseover="showTip\(\'(.*)\'\)"><\/td><td align="left">/', $charline, $matches);
		$race = $matches[1];
		preg_match('/<img src="images\/icons\/class.*onmouseover="showTip\(\'(.*)\'\)"><\/td><td align="center">/', $charline, $matches);
		$class = $matches[1];
		preg_match('/<q>(Rank |<strong class="gm">)(.*)<\/q><\/td>$/', $charline, $matches);
		$rank = $matches[2];
		if (strcmp($rank, "Guild Master</strong>") == 0)//gm's have some weird stuff next to their name
			$rank = 0;
		//print_r($matches);
		echo "$name is level $level and race $race and class $class and rank $rank\n";
		//echo "<TR><TH>$name<TH>$level<TH>$race<TH>$class<TH>$rank";
		//die;
	}
}
?>